# coding: utf-8

"""
    ANTENNEX Reverberation Chamber API

    HTTP API for ANTENNEX The Wireless Connector(tm)

    The version of the OpenAPI document: 3.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class FmcwMetrics(BaseModel):
    """
    Calculated Metrics for a frequency modulated continuous wave (FMCW) measurement.
    """ # noqa: E501
    rate: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="FMCW chirp rate in [Hz/s]")
    offset: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="To be defined")
    rf: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Linearity metric [Hz]", alias="Rf")
    pon: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Power during chirp [dBm]", alias="Pon")
    window_size: Optional[StrictInt] = Field(default=None, description="FFT window size used during measurement", alias="windowSize")
    t_start: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Chirp start time [s]", alias="tStart")
    t_stop: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Chirp stop time [s]", alias="tStop")
    __properties: ClassVar[List[str]] = ["rate", "offset", "Rf", "Pon", "windowSize", "tStart", "tStop"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FmcwMetrics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FmcwMetrics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "rate": obj.get("rate"),
            "offset": obj.get("offset"),
            "Rf": obj.get("Rf"),
            "Pon": obj.get("Pon"),
            "windowSize": obj.get("windowSize"),
            "tStart": obj.get("tStart"),
            "tStop": obj.get("tStop")
        })
        return _obj


