# coding: utf-8

"""
    ANTENNEX Reverberation Chamber API

    HTTP API for ANTENNEX The Wireless Connector(tm)

    The version of the OpenAPI document: 3.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from antennex_client.models.measurement_units import MeasurementUnits
from antennex_client.models.metrics import Metrics
from antennex_client.models.settings import Settings
from typing import Optional, Set
from typing_extensions import Self

class Spectrum(BaseModel):
    """
    Measurement results for a Spectrum. Note that this object is currently re-used to describe any 1D magnitude  measurement result, such as for the calibration files (gain in dB) or PSD files (dBm/Hz). While these are strictly not a Spectrum, the data format is the same. The naming may change in the future.
    """ # noqa: E501
    unit: MeasurementUnits
    settings: Settings
    data: List[Union[StrictFloat, StrictInt]] = Field(description="Spectrum data (real component)")
    imaginary_data: Optional[List[Union[StrictFloat, StrictInt]]] = Field(default=None, description="Spectrum data (imaginary component).", alias="imaginaryData")
    metrics: Optional[Metrics] = None
    __properties: ClassVar[List[str]] = ["unit", "settings", "data", "imaginaryData", "metrics"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Spectrum from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of settings
        if self.settings:
            _dict['settings'] = self.settings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of metrics
        if self.metrics:
            _dict['metrics'] = self.metrics.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Spectrum from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "unit": obj.get("unit"),
            "settings": Settings.from_dict(obj["settings"]) if obj.get("settings") is not None else None,
            "data": obj.get("data"),
            "imaginaryData": obj.get("imaginaryData"),
            "metrics": Metrics.from_dict(obj["metrics"]) if obj.get("metrics") is not None else None
        })
        return _obj


